rc.subr revision 242184
1# $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2# $FreeBSD: head/etc/rc.subr 242184 2012-10-27 19:09:09Z hrs $
3#
4# Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5# All rights reserved.
6#
7# This code is derived from software contributed to The NetBSD Foundation
8# by Luke Mewburn.
9#
10# Redistribution and use in source and binary forms, with or without
11# modification, are permitted provided that the following conditions
12# are met:
13# 1. Redistributions of source code must retain the above copyright
14#    notice, this list of conditions and the following disclaimer.
15# 2. Redistributions in binary form must reproduce the above copyright
16#    notice, this list of conditions and the following disclaimer in the
17#    documentation and/or other materials provided with the distribution.
18#
19# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
20# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
21# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
22# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
23# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
24# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
25# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
26# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
27# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
28# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
29# POSSIBILITY OF SUCH DAMAGE.
30#
31# rc.subr
32#	functions used by various rc scripts
33#
34
35: ${RC_PID:=$$}; export RC_PID
36
37#
38#	Operating System dependent/independent variables
39#
40
41if [ -z "${_rc_subr_loaded}" ]; then
42
43_rc_subr_loaded="YES"
44
45SYSCTL="/sbin/sysctl"
46SYSCTL_N="${SYSCTL} -n"
47SYSCTL_W="${SYSCTL}"
48ID="/usr/bin/id"
49IDCMD="if [ -x $ID ]; then $ID -un; fi"
50PS="/bin/ps -ww"
51JID=`$PS -p $$ -o jid=`
52
53#
54#	functions
55#	---------
56
57# set_rcvar_obsolete oldvar [newvar] [msg]
58#	Define obsolete variable.
59#	Global variable $rcvars_obsolete is used.
60#
61set_rcvar_obsolete()
62{
63	local _var
64	_var=$1
65	debug "rcvar_obsolete: \$$1(old) -> \$$2(new) is defined"
66
67	rcvars_obsolete="${rcvars_obsolete# } $1"
68	eval ${1}_newvar=\"$2\"
69	shift 2
70	eval ${_var}_obsolete_msg=\"$*\"
71}
72
73#
74# force_depend script [rcvar]
75#	Force a service to start. Intended for use by services
76#	to resolve dependency issues.
77#	$1 - filename of script, in /etc/rc.d, to run
78#	$2 - name of the script's rcvar (minus the _enable)
79#
80force_depend()
81{
82	local _depend _dep_rcvar
83
84	_depend="$1"
85	_dep_rcvar="${2:-$1}_enable"
86
87	[ -n "$rc_fast" ] && ! checkyesno always_force_depends &&
88	    checkyesno $_dep_rcvar && return 0
89
90	/etc/rc.d/${_depend} forcestatus >/dev/null 2>&1 && return 0
91
92	info "${name} depends on ${_depend}, which will be forced to start."
93	if ! /etc/rc.d/${_depend} forcestart; then
94		warn "Unable to force ${_depend}. It may already be running."
95		return 1
96	fi
97}
98
99#
100# checkyesno var
101#	Test $1 variable, and warn if not set to YES or NO.
102#	Return 0 if it's "yes" (et al), nonzero otherwise.
103#
104checkyesno()
105{
106	eval _value=\$${1}
107	debug "checkyesno: $1 is set to $_value."
108	case $_value in
109
110		#	"yes", "true", "on", or "1"
111	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
112		return 0
113		;;
114
115		#	"no", "false", "off", or "0"
116	[Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
117		return 1
118		;;
119	*)
120		warn "\$${1} is not set properly - see rc.conf(5)."
121		return 1
122		;;
123	esac
124}
125
126#
127# reverse_list list
128#	print the list in reverse order
129#
130reverse_list()
131{
132	_revlist=
133	for _revfile; do
134		_revlist="$_revfile $_revlist"
135	done
136	echo $_revlist
137}
138
139# stop_boot always
140#	If booting directly to multiuser or $always is enabled,
141#	send SIGTERM to the parent (/etc/rc) to abort the boot.
142#	Otherwise just exit.
143#
144stop_boot()
145{
146	local always
147
148	case $1 in
149		#	"yes", "true", "on", or "1"
150        [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
151		always=true
152		;;
153	*)
154		always=false
155		;;
156	esac
157	if [ "$autoboot" = yes -o "$always" = true ]; then
158		echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
159		kill -TERM ${RC_PID}
160	fi
161	exit 1
162}
163
164#
165# mount_critical_filesystems type
166#	Go through the list of critical filesystems as provided in
167#	the rc.conf(5) variable $critical_filesystems_${type}, checking
168#	each one to see if it is mounted, and if it is not, mounting it.
169#
170mount_critical_filesystems()
171{
172	eval _fslist=\$critical_filesystems_${1}
173	for _fs in $_fslist; do
174		mount | (
175			_ismounted=false
176			while read what _on on _type type; do
177				if [ $on = $_fs ]; then
178					_ismounted=true
179				fi
180			done
181			if $_ismounted; then
182				:
183			else
184				mount $_fs >/dev/null 2>&1
185			fi
186		)
187	done
188}
189
190#
191# check_pidfile pidfile procname [interpreter]
192#	Parses the first line of pidfile for a PID, and ensures
193#	that the process is running and matches procname.
194#	Prints the matching PID upon success, nothing otherwise.
195#	interpreter is optional; see _find_processes() for details.
196#
197check_pidfile()
198{
199	_pidfile=$1
200	_procname=$2
201	_interpreter=$3
202	if [ -z "$_pidfile" -o -z "$_procname" ]; then
203		err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
204	fi
205	if [ ! -f $_pidfile ]; then
206		debug "pid file ($_pidfile): not readable."
207		return
208	fi
209	read _pid _junk < $_pidfile
210	if [ -z "$_pid" ]; then
211		debug "pid file ($_pidfile): no pid in file."
212		return
213	fi
214	_find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
215}
216
217#
218# check_process procname [interpreter]
219#	Ensures that a process (or processes) named procname is running.
220#	Prints a list of matching PIDs.
221#	interpreter is optional; see _find_processes() for details.
222#
223check_process()
224{
225	_procname=$1
226	_interpreter=$2
227	if [ -z "$_procname" ]; then
228		err 3 'USAGE: check_process procname [interpreter]'
229	fi
230	_find_processes $_procname ${_interpreter:-.} '-ax'
231}
232
233#
234# _find_processes procname interpreter psargs
235#	Search for procname in the output of ps generated by psargs.
236#	Prints the PIDs of any matching processes, space separated.
237#
238#	If interpreter == ".", check the following variations of procname
239#	against the first word of each command:
240#		procname
241#		`basename procname`
242#		`basename procname` + ":"
243#		"(" + `basename procname` + ")"
244#		"[" + `basename procname` + "]"
245#
246#	If interpreter != ".", read the first line of procname, remove the
247#	leading #!, normalise whitespace, append procname, and attempt to
248#	match that against each command, either as is, or with extra words
249#	at the end.  As an alternative, to deal with interpreted daemons
250#	using perl, the basename of the interpreter plus a colon is also
251#	tried as the prefix to procname.
252#
253_find_processes()
254{
255	if [ $# -ne 3 ]; then
256		err 3 'USAGE: _find_processes procname interpreter psargs'
257	fi
258	_procname=$1
259	_interpreter=$2
260	_psargs=$3
261
262	_pref=
263	if [ $_interpreter != "." ]; then	# an interpreted script
264		_script="${_chroot}${_chroot:+/}$_procname"
265		if [ -r "$_script" ]; then
266			read _interp < $_script	# read interpreter name
267			case "$_interp" in
268			\#!*)
269				_interp=${_interp#\#!}	# strip #!
270				set -- $_interp
271				case $1 in
272				*/bin/env)
273					shift	# drop env to get real name
274					;;
275				esac
276				if [ $_interpreter != $1 ]; then
277					warn "\$command_interpreter $_interpreter != $1"
278				fi
279				;;
280			*)
281				warn "no shebang line in $_script"
282				set -- $_interpreter
283				;;
284			esac
285		else
286			warn "cannot read shebang line from $_script"
287			set -- $_interpreter
288		fi
289		_interp="$* $_procname"		# cleanup spaces, add _procname
290		_interpbn=${1##*/}
291		_fp_args='_argv'
292		_fp_match='case "$_argv" in
293		    ${_interp}|"${_interp} "*|"${_interpbn}: ${_procname}"*)'
294	else					# a normal daemon
295		_procnamebn=${_procname##*/}
296		_fp_args='_arg0 _argv'
297		_fp_match='case "$_arg0" in
298		    $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
299	fi
300
301	_proccheck="\
302		$PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
303		while read _npid _jid '"$_fp_args"'; do
304			'"$_fp_match"'
305				if [ "$JID" -eq "$_jid" ];
306				then echo -n "$_pref$_npid";
307				_pref=" ";
308				fi
309				;;
310			esac
311		done'
312
313#	debug "in _find_processes: proccheck is ($_proccheck)."
314	eval $_proccheck
315}
316
317#
318# wait_for_pids pid [pid ...]
319#	spins until none of the pids exist
320#
321wait_for_pids()
322{
323	local _list _prefix _nlist _j
324
325	_list="$@"
326	if [ -z "$_list" ]; then
327		return
328	fi
329	_prefix=
330	while true; do
331		_nlist="";
332		for _j in $_list; do
333			if kill -0 $_j 2>/dev/null; then
334				_nlist="${_nlist}${_nlist:+ }$_j"
335				[ -n "$_prefix" ] && sleep 1
336			fi
337		done
338		if [ -z "$_nlist" ]; then
339			break
340		fi
341		_list=$_nlist
342		echo -n ${_prefix:-"Waiting for PIDS: "}$_list
343		_prefix=", "
344		pwait $_list 2>/dev/null
345	done
346	if [ -n "$_prefix" ]; then
347		echo "."
348	fi
349}
350
351#
352# get_pidfile_from_conf string file
353#
354#	Takes a string to search for in the specified file.
355#	Ignores lines with traditional comment characters.
356#
357# Example:
358#
359# if get_pidfile_from_conf string file; then
360#	pidfile="$_pidfile_from_conf"
361# else
362#	pidfile='appropriate default'
363# fi
364#
365get_pidfile_from_conf()
366{
367	if [ -z "$1" -o -z "$2" ]; then
368		err 3 "USAGE: get_pidfile_from_conf string file ($name)"
369	fi
370
371	local string file line
372
373	string="$1" ; file="$2"
374
375	if [ ! -s "$file" ]; then
376		err 3 "get_pidfile_from_conf: $file does not exist ($name)"
377	fi
378
379	while read line; do
380		case "$line" in
381		*[#\;]*${string}*)	continue ;;
382		*${string}*)		break ;;
383		esac
384	done < $file
385
386	if [ -n "$line" ]; then
387		line=${line#*/}
388		_pidfile_from_conf="/${line%%[\"\;]*}"
389	else
390		return 1
391	fi
392}
393
394#
395# check_startmsgs
396#	If rc_quiet is set (usually as a result of using faststart at
397#	boot time) check if rc_startmsgs is enabled.
398#
399check_startmsgs()
400{
401	if [ -n "$rc_quiet" ]; then
402		checkyesno rc_startmsgs
403	else
404		return 0
405	fi
406}
407
408#
409# run_rc_command argument
410#	Search for argument in the list of supported commands, which is:
411#		"start stop restart rcvar status poll ${extra_commands}"
412#	If there's a match, run ${argument}_cmd or the default method
413#	(see below).
414#
415#	If argument has a given prefix, then change the operation as follows:
416#		Prefix	Operation
417#		------	---------
418#		fast	Skip the pid check, and set rc_fast=yes, rc_quiet=yes
419#		force	Set ${rcvar} to YES, and set rc_force=yes
420#		one	Set ${rcvar} to YES
421#		quiet	Don't output some diagnostics, and set rc_quiet=yes
422#
423#	The following globals are used:
424#
425#	Name		Needed	Purpose
426#	----		------	-------
427#	name		y	Name of script.
428#
429#	command		n	Full path to command.
430#				Not needed if ${rc_arg}_cmd is set for
431#				each keyword.
432#
433#	command_args	n	Optional args/shell directives for command.
434#
435#	command_interpreter n	If not empty, command is interpreted, so
436#				call check_{pidfile,process}() appropriately.
437#
438#	desc		n	Description of script.
439#
440#	extra_commands	n	List of extra commands supported.
441#
442#	pidfile		n	If set, use check_pidfile $pidfile $command,
443#				otherwise use check_process $command.
444#				In either case, only check if $command is set.
445#
446#	procname	n	Process name to check for instead of $command.
447#
448#	rcvar		n	This is checked with checkyesno to determine
449#				if the action should be run.
450#
451#	${name}_program	n	Full path to command.
452#				Meant to be used in /etc/rc.conf to override
453#				${command}.
454#
455#	${name}_chroot	n	Directory to chroot to before running ${command}
456#				Requires /usr to be mounted.
457#
458#	${name}_chdir	n	Directory to cd to before running ${command}
459#				(if not using ${name}_chroot).
460#
461#	${name}_flags	n	Arguments to call ${command} with.
462#				NOTE:	$flags from the parent environment
463#					can be used to override this.
464#
465#	${name}_fib	n	Routing table number to run ${command} with.
466#
467#	${name}_nice	n	Nice level to run ${command} at.
468#
469#	${name}_user	n	User to run ${command} as, using su(1) if not
470#				using ${name}_chroot.
471#				Requires /usr to be mounted.
472#
473#	${name}_group	n	Group to run chrooted ${command} as.
474#				Requires /usr to be mounted.
475#
476#	${name}_groups	n	Comma separated list of supplementary groups
477#				to run the chrooted ${command} with.
478#				Requires /usr to be mounted.
479#
480#	${rc_arg}_cmd	n	If set, use this as the method when invoked;
481#				Otherwise, use default command (see below)
482#
483#	${rc_arg}_precmd n	If set, run just before performing the
484#				${rc_arg}_cmd method in the default
485#				operation (i.e, after checking for required
486#				bits and process (non)existence).
487#				If this completes with a non-zero exit code,
488#				don't run ${rc_arg}_cmd.
489#
490#	${rc_arg}_postcmd n	If set, run just after performing the
491#				${rc_arg}_cmd method, if that method
492#				returned a zero exit code.
493#
494#	required_dirs	n	If set, check for the existence of the given
495#				directories before running a (re)start command.
496#
497#	required_files	n	If set, check for the readability of the given
498#				files before running a (re)start command.
499#
500#	required_modules n	If set, ensure the given kernel modules are
501#				loaded before running a (re)start command.
502#				The check and possible loads are actually
503#				done after start_precmd so that the modules
504#				aren't loaded in vain, should the precmd
505#				return a non-zero status to indicate a error.
506#				If a word in the list looks like "foo:bar",
507#				"foo" is the KLD file name and "bar" is the
508#				module name.  If a word looks like "foo~bar",
509#				"foo" is the KLD file name and "bar" is a
510#				egrep(1) pattern matching the module name.
511#				Otherwise the module name is assumed to be
512#				the same as the KLD file name, which is most
513#				common.  See load_kld().
514#
515#	required_vars	n	If set, perform checkyesno on each of the
516#				listed variables before running the default
517#				(re)start command.
518#
519#	Default behaviour for a given argument, if no override method is
520#	provided:
521#
522#	Argument	Default behaviour
523#	--------	-----------------
524#	start		if !running && checkyesno ${rcvar}
525#				${command}
526#
527#	stop		if ${pidfile}
528#				rc_pid=$(check_pidfile $pidfile $command)
529#			else
530#				rc_pid=$(check_process $command)
531#			kill $sig_stop $rc_pid
532#			wait_for_pids $rc_pid
533#			($sig_stop defaults to TERM.)
534#
535#	reload		Similar to stop, except use $sig_reload instead,
536#			and doesn't wait_for_pids.
537#			$sig_reload defaults to HUP.
538#			Note that `reload' isn't provided by default,
539#			it should be enabled via $extra_commands.
540#
541#	restart		Run `stop' then `start'.
542#
543#	status		Show if ${command} is running, etc.
544#
545#	poll		Wait for ${command} to exit.
546#
547#	rcvar		Display what rc.conf variable is used (if any).
548#
549#	Variables available to methods, and after run_rc_command() has
550#	completed:
551#
552#	Variable	Purpose
553#	--------	-------
554#	rc_arg		Argument to command, after fast/force/one processing
555#			performed
556#
557#	rc_flags	Flags to start the default command with.
558#			Defaults to ${name}_flags, unless overridden
559#			by $flags from the environment.
560#			This variable may be changed by the precmd method.
561#
562#	rc_pid		PID of command (if appropriate)
563#
564#	rc_fast		Not empty if "fast" was provided (q.v.)
565#
566#	rc_force	Not empty if "force" was provided (q.v.)
567#
568#	rc_quiet	Not empty if "quiet" was provided
569#
570#
571run_rc_command()
572{
573	_return=0
574	rc_arg=$1
575	if [ -z "$name" ]; then
576		err 3 'run_rc_command: $name is not set.'
577	fi
578
579	# Don't repeat the first argument when passing additional command-
580	# line arguments to the command subroutines.
581	#
582	shift 1
583	rc_extra_args="$*"
584
585	_rc_prefix=
586	case "$rc_arg" in
587	fast*)				# "fast" prefix; don't check pid
588		rc_arg=${rc_arg#fast}
589		rc_fast=yes
590		rc_quiet=yes
591		;;
592	force*)				# "force" prefix; always run
593		rc_force=yes
594		_rc_prefix=force
595		rc_arg=${rc_arg#${_rc_prefix}}
596		if [ -n "${rcvar}" ]; then
597			eval ${rcvar}=YES
598		fi
599		;;
600	one*)				# "one" prefix; set ${rcvar}=yes
601		_rc_prefix=one
602		rc_arg=${rc_arg#${_rc_prefix}}
603		if [ -n "${rcvar}" ]; then
604			eval ${rcvar}=YES
605		fi
606		;;
607	quiet*)				# "quiet" prefix; omit some messages
608		_rc_prefix=quiet
609		rc_arg=${rc_arg#${_rc_prefix}}
610		rc_quiet=yes
611		;;
612	esac
613
614	eval _override_command=\$${name}_program
615	command=${_override_command:-$command}
616
617	_keywords="start stop restart rcvar $extra_commands"
618	rc_pid=
619	_pidcmd=
620	_procname=${procname:-${command}}
621
622					# setup pid check command
623	if [ -n "$_procname" ]; then
624		if [ -n "$pidfile" ]; then
625			_pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
626		else
627			_pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
628		fi
629		if [ -n "$_pidcmd" ]; then
630			_keywords="${_keywords} status poll"
631		fi
632	fi
633
634	if [ -z "$rc_arg" ]; then
635		rc_usage $_keywords
636	fi
637
638	if [ -n "$flags" ]; then	# allow override from environment
639		rc_flags=$flags
640	else
641		eval rc_flags=\$${name}_flags
642	fi
643	eval _chdir=\$${name}_chdir	_chroot=\$${name}_chroot \
644	    _nice=\$${name}_nice	_user=\$${name}_user \
645	    _group=\$${name}_group	_groups=\$${name}_groups \
646	    _fib=\$${name}_fib
647
648	if [ -n "$_user" ]; then	# unset $_user if running as that user
649		if [ "$_user" = "$(eval $IDCMD)" ]; then
650			unset _user
651		fi
652	fi
653
654	[ -z "$autoboot" ] && eval $_pidcmd	# determine the pid if necessary
655
656	for _elem in $_keywords; do
657		if [ "$_elem" != "$rc_arg" ]; then
658			continue
659		fi
660					# if ${rcvar} is set, $1 is not "rcvar"
661					# and ${rc_pid} is not set, then run
662					#	checkyesno ${rcvar}
663					# and return if that failed
664					#
665		if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" -a "$rc_arg" != "stop" ] ||
666		    [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
667			if ! checkyesno ${rcvar}; then
668				if [ -n "${rc_quiet}" ]; then
669					return 0
670				fi
671				echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
672				echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
673				echo "instead of '${rc_arg}'."
674				return 0
675			fi
676		fi
677
678					# if there's a custom ${XXX_cmd},
679					# run that instead of the default
680					#
681		eval _cmd=\$${rc_arg}_cmd \
682		     _precmd=\$${rc_arg}_precmd \
683		     _postcmd=\$${rc_arg}_postcmd
684
685		if [ -n "$_cmd" ]; then
686			_run_rc_precmd || return 1
687			_run_rc_doit "$_cmd $rc_extra_args" || return 1
688			_run_rc_postcmd
689			return $_return
690		fi
691
692		case "$rc_arg" in	# default operations...
693
694		status)
695			_run_rc_precmd || return 1
696			if [ -n "$rc_pid" ]; then
697				echo "${name} is running as pid $rc_pid."
698			else
699				echo "${name} is not running."
700				return 1
701			fi
702			_run_rc_postcmd
703			;;
704
705		start)
706			if [ -z "$rc_fast" -a -n "$rc_pid" ]; then
707				echo 1>&2 "${name} already running? (pid=$rc_pid)."
708				return 1
709			fi
710
711			if [ ! -x "${_chroot}${_chroot:+/}${command}" ]; then
712				warn "run_rc_command: cannot run $command"
713				return 1
714			fi
715
716			if ! _run_rc_precmd; then
717				warn "failed precmd routine for ${name}"
718				return 1
719			fi
720
721					# setup the full command to run
722					#
723			check_startmsgs && echo "Starting ${name}."
724			if [ -n "$_chroot" ]; then
725				_doit="\
726${_nice:+nice -n $_nice }\
727${_fib:+setfib -F $_fib }\
728chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
729$_chroot $command $rc_flags $command_args"
730			else
731				_doit="\
732${_chdir:+cd $_chdir && }\
733${_fib:+setfib -F $_fib }\
734$command $rc_flags $command_args"
735				if [ -n "$_user" ]; then
736				    _doit="su -m $_user -c 'sh -c \"$_doit\"'"
737				fi
738				if [ -n "$_nice" ]; then
739					if [ -z "$_user" ]; then
740						_doit="sh -c \"$_doit\""
741					fi
742					_doit="nice -n $_nice $_doit"
743				fi
744			fi
745
746					# run the full command
747					#
748			if ! _run_rc_doit "$_doit"; then
749				warn "failed to start ${name}"
750				return 1
751			fi
752
753					# finally, run postcmd
754					#
755			_run_rc_postcmd
756			;;
757
758		stop)
759			if [ -z "$rc_pid" ]; then
760				[ -n "$rc_fast" ] && return 0
761				_run_rc_notrunning
762				return 1
763			fi
764
765			_run_rc_precmd || return 1
766
767					# send the signal to stop
768					#
769			echo "Stopping ${name}."
770			_doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
771			_run_rc_doit "$_doit" || return 1
772
773					# wait for the command to exit,
774					# and run postcmd.
775			wait_for_pids $rc_pid
776
777			_run_rc_postcmd
778			;;
779
780		reload)
781			if [ -z "$rc_pid" ]; then
782				_run_rc_notrunning
783				return 1
784			fi
785
786			_run_rc_precmd || return 1
787
788			_doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
789			_run_rc_doit "$_doit" || return 1
790
791			_run_rc_postcmd
792			;;
793
794		restart)
795					# prevent restart being called more
796					# than once by any given script
797					#
798			if ${_rc_restart_done:-false}; then
799				return 0
800			fi
801			_rc_restart_done=true
802
803			_run_rc_precmd || return 1
804
805			# run those in a subshell to keep global variables
806			( run_rc_command ${_rc_prefix}stop $rc_extra_args )
807			( run_rc_command ${_rc_prefix}start $rc_extra_args )
808			_return=$?
809			[ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
810
811			_run_rc_postcmd
812			;;
813
814		poll)
815			_run_rc_precmd || return 1
816			if [ -n "$rc_pid" ]; then
817				wait_for_pids $rc_pid
818			fi
819			_run_rc_postcmd
820			;;
821
822		rcvar)
823			echo -n "# $name"
824			if [ -n "$desc" ]; then
825				echo " : $desc"
826			else
827				echo ""
828			fi
829			echo "#"
830			# Get unique vars in $rcvar
831			for _v in $rcvar; do
832				case $v in
833				$_v\ *|\ *$_v|*\ $_v\ *) ;;
834				*)	v="${v# } $_v" ;;
835				esac
836			done
837
838			# Display variables.
839			for _v in $v; do
840				if [ -z "$_v" ]; then
841					continue
842				fi
843
844				eval _desc=\$${_v}_desc
845				eval _defval=\$${_v}_defval
846				_h="-"
847
848				eval echo \"$_v=\\\"\$$_v\\\"\"
849				# decode multiple lines of _desc
850				while [ -n "$_desc" ]; do
851					case $_desc in
852					*^^*)
853						echo "# $_h ${_desc%%^^*}"
854						_desc=${_desc#*^^}
855						_h=" "
856						;;
857					*)
858						echo "# $_h ${_desc}"
859						break
860						;;
861					esac
862				done
863				echo "#   (default: \"$_defval\")"
864			done
865			echo ""
866			;;
867
868		*)
869			rc_usage $_keywords
870			;;
871
872		esac
873		return $_return
874	done
875
876	echo 1>&2 "$0: unknown directive '$rc_arg'."
877	rc_usage $_keywords
878	# not reached
879}
880
881#
882# Helper functions for run_rc_command: common code.
883# They use such global variables besides the exported rc_* ones:
884#
885#	name	       R/W
886#	------------------
887#	_precmd		R
888#	_postcmd	R
889#	_return		W
890#
891_run_rc_precmd()
892{
893	check_required_before "$rc_arg" || return 1
894
895	if [ -n "$_precmd" ]; then
896		debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
897		eval "$_precmd $rc_extra_args"
898		_return=$?
899
900		# If precmd failed and force isn't set, request exit.
901		if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
902			return 1
903		fi
904	fi
905
906	check_required_after "$rc_arg" || return 1
907
908	return 0
909}
910
911_run_rc_postcmd()
912{
913	if [ -n "$_postcmd" ]; then
914		debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
915		eval "$_postcmd $rc_extra_args"
916		_return=$?
917	fi
918	return 0
919}
920
921_run_rc_doit()
922{
923	debug "run_rc_command: doit: $*"
924	eval "$@"
925	_return=$?
926
927	# If command failed and force isn't set, request exit.
928	if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
929		return 1
930	fi
931
932	return 0
933}
934
935_run_rc_notrunning()
936{
937	local _pidmsg
938
939	if [ -n "$pidfile" ]; then
940		_pidmsg=" (check $pidfile)."
941	else
942		_pidmsg=
943	fi
944	echo 1>&2 "${name} not running?${_pidmsg}"
945}
946
947_run_rc_killcmd()
948{
949	local _cmd
950
951	_cmd="kill -$1 $rc_pid"
952	if [ -n "$_user" ]; then
953		_cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
954	fi
955	echo "$_cmd"
956}
957
958#
959# run_rc_script file arg
960#	Start the script `file' with `arg', and correctly handle the
961#	return value from the script.
962#	If `file' ends with `.sh', it's sourced into the current environment
963#	when $rc_fast_and_loose is set, otherwise it is run as a child process.
964#	If `file' appears to be a backup or scratch file, ignore it.
965#	Otherwise if it is executable run as a child process.
966#
967run_rc_script()
968{
969	_file=$1
970	_arg=$2
971	if [ -z "$_file" -o -z "$_arg" ]; then
972		err 3 'USAGE: run_rc_script file arg'
973	fi
974
975	unset	name command command_args command_interpreter \
976		extra_commands pidfile procname \
977		rcvar rcvars_obsolete required_dirs required_files \
978		required_vars
979	eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
980
981	case "$_file" in
982	/etc/rc.d/*.sh)			# no longer allowed in the base
983		warn "Ignoring old-style startup script $_file"
984		;;
985	*[~#]|*.OLD|*.bak|*.orig|*,v)	# scratch file; skip
986		warn "Ignoring scratch file $_file"
987		;;
988	*)				# run in subshell
989		if [ -x $_file ]; then
990			if [ -n "$rc_fast_and_loose" ]; then
991				set $_arg; . $_file
992			else
993				( trap "echo Script $_file interrupted >&2 ; kill -QUIT $$" 3
994				  trap "echo Script $_file interrupted >&2 ; exit 1" 2
995				  trap "echo Script $_file running >&2" 29
996				  set $_arg; . $_file )
997			fi
998		fi
999		;;
1000	esac
1001}
1002
1003#
1004# load_rc_config name
1005#	Source in the configuration file for a given name.
1006#
1007load_rc_config()
1008{
1009	local _name _rcvar_val _var _defval _v _msg _new
1010	_name=$1
1011	if [ -z "$_name" ]; then
1012		err 3 'USAGE: load_rc_config name'
1013	fi
1014
1015	if ${_rc_conf_loaded:-false}; then
1016		:
1017	else
1018		if [ -r /etc/defaults/rc.conf ]; then
1019			debug "Sourcing /etc/defaults/rc.conf"
1020			. /etc/defaults/rc.conf
1021			source_rc_confs
1022		elif [ -r /etc/rc.conf ]; then
1023			debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
1024			. /etc/rc.conf
1025		fi
1026		_rc_conf_loaded=true
1027	fi
1028	if [ -f /etc/rc.conf.d/"$_name" ]; then
1029		debug "Sourcing /etc/rc.conf.d/${_name}"
1030		. /etc/rc.conf.d/"$_name"
1031	fi
1032
1033	# Set defaults if defined.
1034	for _var in $rcvar; do
1035		eval _defval=\$${_var}_defval
1036		if [ -n "$_defval" ]; then
1037			eval : \${$_var:=\$${_var}_defval}
1038		fi
1039	done
1040
1041	# check obsolete rc.conf variables
1042	for _var in $rcvars_obsolete; do
1043		eval _v=\$$_var
1044		eval _msg=\$${_var}_obsolete_msg
1045		eval _new=\$${_var}_newvar
1046		case $_v in
1047		"")
1048			;;
1049		*)
1050			if [ -z "$_new" ]; then
1051				_msg="Ignored."
1052			else
1053				eval $_new=\"\$$_var\"
1054				if [ -z "$_msg" ]; then
1055					_msg="Use \$$_new instead."
1056				fi
1057			fi
1058			warn "\$$_var is obsolete.  $_msg"
1059			;;
1060		esac
1061	done
1062}
1063
1064#
1065# load_rc_config_var name var
1066#	Read the rc.conf(5) var for name and set in the
1067#	current shell, using load_rc_config in a subshell to prevent
1068#	unwanted side effects from other variable assignments.
1069#
1070load_rc_config_var()
1071{
1072	if [ $# -ne 2 ]; then
1073		err 3 'USAGE: load_rc_config_var name var'
1074	fi
1075	eval $(eval '(
1076		load_rc_config '$1' >/dev/null;
1077                if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
1078			echo '$2'=\'\''${'$2'}\'\'';
1079		fi
1080	)' )
1081}
1082
1083#
1084# rc_usage commands
1085#	Print a usage string for $0, with `commands' being a list of
1086#	valid commands.
1087#
1088rc_usage()
1089{
1090	echo -n 1>&2 "Usage: $0 [fast|force|one|quiet]("
1091
1092	_sep=
1093	for _elem; do
1094		echo -n 1>&2 "$_sep$_elem"
1095		_sep="|"
1096	done
1097	echo 1>&2 ")"
1098	exit 1
1099}
1100
1101#
1102# err exitval message
1103#	Display message to stderr and log to the syslog, and exit with exitval.
1104#
1105err()
1106{
1107	exitval=$1
1108	shift
1109
1110	if [ -x /usr/bin/logger ]; then
1111		logger "$0: ERROR: $*"
1112	fi
1113	echo 1>&2 "$0: ERROR: $*"
1114	exit $exitval
1115}
1116
1117#
1118# warn message
1119#	Display message to stderr and log to the syslog.
1120#
1121warn()
1122{
1123	if [ -x /usr/bin/logger ]; then
1124		logger "$0: WARNING: $*"
1125	fi
1126	echo 1>&2 "$0: WARNING: $*"
1127}
1128
1129#
1130# info message
1131#	Display informational message to stdout and log to syslog.
1132#
1133info()
1134{
1135	case ${rc_info} in
1136	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1137		if [ -x /usr/bin/logger ]; then
1138			logger "$0: INFO: $*"
1139		fi
1140		echo "$0: INFO: $*"
1141		;;
1142	esac
1143}
1144
1145#
1146# debug message
1147#	If debugging is enabled in rc.conf output message to stderr.
1148#	BEWARE that you don't call any subroutine that itself calls this
1149#	function.
1150#
1151debug()
1152{
1153	case ${rc_debug} in
1154	[Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1155		if [ -x /usr/bin/logger ]; then
1156			logger "$0: DEBUG: $*"
1157		fi
1158		echo 1>&2 "$0: DEBUG: $*"
1159		;;
1160	esac
1161}
1162
1163#
1164# backup_file action file cur backup
1165#	Make a backup copy of `file' into `cur', and save the previous
1166#	version of `cur' as `backup' or use rcs for archiving.
1167#
1168#	This routine checks the value of the backup_uses_rcs variable,
1169#	which can be either YES or NO.
1170#
1171#	The `action' keyword can be one of the following:
1172#
1173#	add		`file' is now being backed up (and is possibly
1174#			being reentered into the backups system).  `cur'
1175#			is created and RCS files, if necessary, are
1176#			created as well.
1177#
1178#	update		`file' has changed and needs to be backed up.
1179#			If `cur' exists, it is copied to to `back' or
1180#			checked into RCS (if the repository file is old),
1181#			and then `file' is copied to `cur'.  Another RCS
1182#			check in done here if RCS is being used.
1183#
1184#	remove		`file' is no longer being tracked by the backups
1185#			system.  If RCS is not being used, `cur' is moved
1186#			to `back', otherwise an empty file is checked in,
1187#			and then `cur' is removed.
1188#
1189#
1190backup_file()
1191{
1192	_action=$1
1193	_file=$2
1194	_cur=$3
1195	_back=$4
1196
1197	if checkyesno backup_uses_rcs; then
1198		_msg0="backup archive"
1199		_msg1="update"
1200
1201		# ensure that history file is not locked
1202		if [ -f $_cur,v ]; then
1203			rcs -q -u -U -M $_cur
1204		fi
1205
1206		# ensure after switching to rcs that the
1207		# current backup is not lost
1208		if [ -f $_cur ]; then
1209			# no archive, or current newer than archive
1210			if [ ! -f $_cur,v -o $_cur -nt $_cur,v ]; then
1211				ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1212				rcs -q -kb -U $_cur
1213				co -q -f -u $_cur
1214			fi
1215		fi
1216
1217		case $_action in
1218		add|update)
1219			cp -p $_file $_cur
1220			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1221			rcs -q -kb -U $_cur
1222			co -q -f -u $_cur
1223			chown root:wheel $_cur $_cur,v
1224			;;
1225		remove)
1226			cp /dev/null $_cur
1227			ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1228			rcs -q -kb -U $_cur
1229			chown root:wheel $_cur $_cur,v
1230			rm $_cur
1231			;;
1232		esac
1233	else
1234		case $_action in
1235		add|update)
1236			if [ -f $_cur ]; then
1237				cp -p $_cur $_back
1238			fi
1239			cp -p $_file $_cur
1240			chown root:wheel $_cur
1241			;;
1242		remove)
1243			mv -f $_cur $_back
1244			;;
1245		esac
1246	fi
1247}
1248
1249# make_symlink src link
1250#	Make a symbolic link 'link' to src from basedir. If the
1251#	directory in which link is to be created does not exist
1252#	a warning will be displayed and an error will be returned.
1253#	Returns 0 on success, 1 otherwise.
1254#
1255make_symlink()
1256{
1257	local src link linkdir _me
1258	src="$1"
1259	link="$2"
1260	linkdir="`dirname $link`"
1261	_me="make_symlink()"
1262
1263	if [ -z "$src" -o -z "$link" ]; then
1264		warn "$_me: requires two arguments."
1265		return 1
1266	fi
1267	if [ ! -d "$linkdir" ]; then
1268		warn "$_me: the directory $linkdir does not exist."
1269		return 1
1270	fi
1271	if ! ln -sf $src $link; then
1272		warn "$_me: unable to make a symbolic link from $link to $src"
1273		return 1
1274	fi
1275	return 0
1276}
1277
1278# devfs_rulesets_from_file file
1279#	Reads a set of devfs commands from file, and creates
1280#	the specified rulesets with their rules. Returns non-zero
1281#	if there was an error.
1282#
1283devfs_rulesets_from_file()
1284{
1285	local file _err _me
1286	file="$1"
1287	_me="devfs_rulesets_from_file"
1288	_err=0
1289
1290	if [ -z "$file" ]; then
1291		warn "$_me: you must specify a file"
1292		return 1
1293	fi
1294	if [ ! -e "$file" ]; then
1295		debug "$_me: no such file ($file)"
1296		return 0
1297	fi
1298	debug "reading rulesets from file ($file)"
1299	{ while read line
1300	do
1301		case $line in
1302		\#*)
1303			continue
1304			;;
1305		\[*\]*)
1306			rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1307			if [ -z "$rulenum" ]; then
1308				warn "$_me: cannot extract rule number ($line)"
1309				_err=1
1310				break
1311			fi
1312			rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1313			if [ -z "$rulename" ]; then
1314				warn "$_me: cannot extract rule name ($line)"
1315				_err=1
1316				break;
1317			fi
1318			eval $rulename=\$rulenum
1319			debug "found ruleset: $rulename=$rulenum"
1320			if ! /sbin/devfs rule -s $rulenum delset; then
1321				_err=1
1322				break
1323			fi
1324			;;
1325		*)
1326			rulecmd="${line%%"\#*"}"
1327			# evaluate the command incase it includes
1328			# other rules
1329			if [ -n "$rulecmd" ]; then
1330				debug "adding rule ($rulecmd)"
1331				if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1332				then
1333					_err=1
1334					break
1335				fi
1336			fi
1337			;;
1338		esac
1339		if [ $_err -ne 0 ]; then
1340			debug "error in $_me"
1341			break
1342		fi
1343	done } < $file
1344	return $_err
1345}
1346
1347# devfs_init_rulesets
1348#	Initializes rulesets from configuration files. Returns
1349#	non-zero if there was an error.
1350#
1351devfs_init_rulesets()
1352{
1353	local file _me
1354	_me="devfs_init_rulesets"
1355
1356	# Go through this only once
1357	if [ -n "$devfs_rulesets_init" ]; then
1358		debug "$_me: devfs rulesets already initialized"
1359		return
1360	fi
1361	for file in $devfs_rulesets; do
1362		if ! devfs_rulesets_from_file $file; then
1363			warn "$_me: could not read rules from $file"
1364			return 1
1365		fi
1366	done
1367	devfs_rulesets_init=1
1368	debug "$_me: devfs rulesets initialized"
1369	return 0
1370}
1371
1372# devfs_set_ruleset ruleset [dir]
1373#	Sets the default ruleset of dir to ruleset. The ruleset argument
1374#	must be a ruleset name as specified in devfs.rules(5) file.
1375#	Returns non-zero if it could not set it successfully.
1376#
1377devfs_set_ruleset()
1378{
1379	local devdir rs _me
1380	[ -n "$1" ] && eval rs=\$$1 || rs=
1381	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1382	_me="devfs_set_ruleset"
1383
1384	if [ -z "$rs" ]; then
1385		warn "$_me: you must specify a ruleset number"
1386		return 1
1387	fi
1388	debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1389	if ! /sbin/devfs $devdir ruleset $rs; then
1390		warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1391		return 1
1392	fi
1393	return 0
1394}
1395
1396# devfs_apply_ruleset ruleset [dir]
1397#	Apply ruleset number $ruleset to the devfs mountpoint $dir.
1398#	The ruleset argument must be a ruleset name as specified
1399#	in a devfs.rules(5) file.  Returns 0 on success or non-zero
1400#	if it could not apply the ruleset.
1401#
1402devfs_apply_ruleset()
1403{
1404	local devdir rs _me
1405	[ -n "$1" ] && eval rs=\$$1 || rs=
1406	[ -n "$2" ] && devdir="-m "$2"" || devdir=
1407	_me="devfs_apply_ruleset"
1408
1409	if [ -z "$rs" ]; then
1410		warn "$_me: you must specify a ruleset"
1411		return 1
1412	fi
1413	debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1414	if ! /sbin/devfs $devdir rule -s $rs applyset; then
1415		warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1416		return 1
1417	fi
1418	return 0
1419}
1420
1421# devfs_domount dir [ruleset]
1422#	Mount devfs on dir. If ruleset is specified it is set
1423#	on the mount-point. It must also be a ruleset name as specified
1424#	in a devfs.rules(5) file. Returns 0 on success.
1425#
1426devfs_domount()
1427{
1428	local devdir rs _me
1429	devdir="$1"
1430	[ -n "$2" ] && rs=$2 || rs=
1431	_me="devfs_domount()"
1432
1433	if [ -z "$devdir" ]; then
1434		warn "$_me: you must specify a mount-point"
1435		return 1
1436	fi
1437	debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1438	if ! mount -t devfs dev "$devdir"; then
1439		warn "$_me: Unable to mount devfs on $devdir"
1440		return 1
1441	fi
1442	if [ -n "$rs" ]; then
1443		devfs_init_rulesets
1444		devfs_set_ruleset $rs $devdir
1445		devfs -m $devdir rule applyset
1446	fi
1447	return 0
1448}
1449
1450# devfs_mount_jail dir [ruleset]
1451#	Mounts a devfs file system appropriate for jails
1452#	on the directory dir. If ruleset is specified, the ruleset
1453#	it names will be used instead.  If present, ruleset must
1454#	be the name of a ruleset as defined in a devfs.rules(5) file.
1455#	This function returns non-zero if an error occurs.
1456#
1457devfs_mount_jail()
1458{
1459	local jdev rs _me
1460	jdev="$1"
1461	[ -n "$2" ] && rs=$2 || rs="devfsrules_jail"
1462	_me="devfs_mount_jail"
1463
1464	devfs_init_rulesets
1465	if ! devfs_domount "$jdev" $rs; then
1466		warn "$_me: devfs was not mounted on $jdev"
1467		return 1
1468	fi
1469	return 0
1470}
1471
1472# Provide a function for normalizing the mounting of memory
1473# filesystems.  This should allow the rest of the code here to remain
1474# as close as possible between 5-current and 4-stable.
1475#   $1 = size
1476#   $2 = mount point
1477#   $3 = (optional) extra mdmfs flags
1478mount_md()
1479{
1480	if [ -n "$3" ]; then
1481		flags="$3"
1482	fi
1483	/sbin/mdmfs $flags -s $1 md $2
1484}
1485
1486# Code common to scripts that need to load a kernel module
1487# if it isn't in the kernel yet. Syntax:
1488#   load_kld [-e regex] [-m module] file
1489# where -e or -m chooses the way to check if the module
1490# is already loaded:
1491#   regex is egrep'd in the output from `kldstat -v',
1492#   module is passed to `kldstat -m'.
1493# The default way is as though `-m file' were specified.
1494load_kld()
1495{
1496	local _loaded _mod _opt _re
1497
1498	while getopts "e:m:" _opt; do
1499		case "$_opt" in
1500		e) _re="$OPTARG" ;;
1501		m) _mod="$OPTARG" ;;
1502		*) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1503		esac
1504	done
1505	shift $(($OPTIND - 1))
1506	if [ $# -ne 1 ]; then
1507		err 3 'USAGE: load_kld [-e regex] [-m module] file'
1508	fi
1509	_mod=${_mod:-$1}
1510	_loaded=false
1511	if [ -n "$_re" ]; then
1512		if kldstat -v | egrep -q -e "$_re"; then
1513			_loaded=true
1514		fi
1515	else
1516		if kldstat -q -m "$_mod"; then
1517			_loaded=true
1518		fi
1519	fi
1520	if ! $_loaded; then
1521		if ! kldload "$1"; then
1522			warn "Unable to load kernel module $1"
1523			return 1
1524		else
1525			info "$1 kernel module loaded."
1526		fi
1527	else
1528		debug "load_kld: $1 kernel module already loaded."
1529	fi
1530	return 0
1531}
1532
1533# ltr str src dst
1534#	Change every $src in $str to $dst.
1535#	Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1536#	awk(1).
1537ltr()
1538{
1539	local _str _src _dst _out _com
1540	_str=$1
1541	_src=$2
1542	_dst=$3
1543	_out=""
1544
1545	IFS=${_src}
1546	for _com in ${_str}; do
1547		if [ -z "${_out}" ]; then
1548			_out="${_com}"
1549		else
1550			_out="${_out}${_dst}${_com}"
1551		fi
1552	done
1553	echo "${_out}"
1554}
1555
1556# Creates a list of providers for GELI encryption.
1557geli_make_list()
1558{
1559	local devices devices2
1560	local provider mountpoint type options rest
1561
1562	# Create list of GELI providers from fstab.
1563	while read provider mountpoint type options rest ; do
1564		case ":${options}" in
1565		:*noauto*)
1566			noauto=yes
1567			;;
1568		*)
1569			noauto=no
1570			;;
1571		esac
1572
1573		case ":${provider}" in
1574		:#*)
1575			continue
1576			;;
1577		*.eli)
1578			# Skip swap devices.
1579			if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1580				continue
1581			fi
1582			devices="${devices} ${provider}"
1583			;;
1584		esac
1585	done < /etc/fstab
1586
1587	# Append providers from geli_devices.
1588	devices="${devices} ${geli_devices}"
1589
1590	for provider in ${devices}; do
1591		provider=${provider%.eli}
1592		provider=${provider#/dev/}
1593		devices2="${devices2} ${provider}"
1594	done
1595
1596	echo ${devices2}
1597}
1598
1599# Find scripts in local_startup directories that use the old syntax
1600#
1601find_local_scripts_old() {
1602	zlist=''
1603	slist=''
1604	for dir in ${local_startup}; do
1605		if [ -d "${dir}" ]; then
1606			for file in ${dir}/[0-9]*.sh; do
1607				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1608				    continue
1609				zlist="$zlist $file"
1610			done
1611			for file in ${dir}/[!0-9]*.sh; do
1612				grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1613				    continue
1614				slist="$slist $file"
1615			done
1616		fi
1617	done
1618}
1619
1620find_local_scripts_new() {
1621	local_rc=''
1622	for dir in ${local_startup}; do
1623		if [ -d "${dir}" ]; then
1624			for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1625				case "$file" in
1626				*.sample) ;;
1627				*)	if [ -x "$file" ]; then
1628						local_rc="${local_rc} ${file}"
1629					fi
1630					;;
1631				esac
1632			done
1633		fi
1634	done
1635}
1636
1637# check_required_{before|after} command
1638#	Check for things required by the command before and after its precmd,
1639#	respectively.  The two separate functions are needed because some
1640#	conditions should prevent precmd from being run while other things
1641#	depend on precmd having already been run.
1642#
1643check_required_before()
1644{
1645	local _f
1646
1647	case "$1" in
1648	start)
1649		for _f in $required_vars; do
1650			if ! checkyesno $_f; then
1651				warn "\$${_f} is not enabled."
1652				if [ -z "$rc_force" ]; then
1653					return 1
1654				fi
1655			fi
1656		done
1657
1658		for _f in $required_dirs; do
1659			if [ ! -d "${_f}/." ]; then
1660				warn "${_f} is not a directory."
1661				if [ -z "$rc_force" ]; then
1662					return 1
1663				fi
1664			fi
1665		done
1666
1667		for _f in $required_files; do
1668			if [ ! -r "${_f}" ]; then
1669				warn "${_f} is not readable."
1670				if [ -z "$rc_force" ]; then
1671					return 1
1672				fi
1673			fi
1674		done
1675		;;
1676	esac
1677
1678	return 0
1679}
1680
1681check_required_after()
1682{
1683	local _f _args
1684
1685	case "$1" in
1686	start)
1687		for _f in $required_modules; do
1688			case "${_f}" in
1689				*~*)	_args="-e ${_f#*~} ${_f%%~*}" ;;
1690				*:*)	_args="-m ${_f#*:} ${_f%%:*}" ;;
1691				*)	_args="${_f}" ;;
1692			esac
1693			if ! load_kld ${_args}; then
1694				if [ -z "$rc_force" ]; then
1695					return 1
1696				fi
1697			fi
1698		done
1699		;;
1700	esac
1701
1702	return 0
1703}
1704
1705# check_kern_features mib
1706#	Return existence of kern.features.* sysctl MIB as true or
1707#	false.  The result will be cached in $_rc_cache_kern_features_
1708#	namespace.  "0" means the kern.features.X exists.
1709
1710check_kern_features()
1711{
1712	local _v
1713
1714	[ -n "$1" ] || return 1;
1715	eval _v=\$_rc_cache_kern_features_$1
1716	[ -n "$_v" ] && return "$_v";
1717
1718	if ${SYSCTL_N} kern.features.$1 > /dev/null 2>&1; then
1719		eval _rc_cache_kern_features_$1=0
1720		return 0
1721	else
1722		eval _rc_cache_kern_features_$1=1
1723		return 1
1724	fi
1725}
1726
1727# _echoonce var msg mode
1728#	mode=0: Echo $msg if ${$var} is empty.
1729#	        After doing echo, a string is set to ${$var}.
1730#
1731#	mode=1: Echo $msg if ${$var} is a string with non-zero length.
1732#
1733_echoonce()
1734{
1735	local _var _msg _mode
1736	eval _var=\$$1
1737	_msg=$2
1738	_mode=$3
1739
1740	case $_mode in
1741	1)	[ -n "$_var" ] && echo "$_msg" ;;
1742	*)	[ -z "$_var" ] && echo -n "$_msg" && eval "$1=finished" ;;
1743	esac
1744}
1745
1746fi # [ -z "${_rc_subr_loaded}" ]
1747
1748_rc_subr_loaded=:
1749